<?php
    use PFBC\Form;
    use PFBC\Element;
    use PFBC\View;
    use PFBC\Validation;
    use documongo\MongoObject\Document;
    use documongo\MongoObject\DocumentType;
    require_once('lib/fconnect.php');
	$db = DBConnect::getInstance();
    require_once('lib/frole.php');
	$role = new Role();
	
	function divide_on_the_rates($chislo, $rates, $round = 5){
		return round($chislo/$rates,$round);
	}
	function actuation($array,$value){
		arsort($array);
		$max = reset($array);
		if($max == 0) return 0;
		$percent = ($max)/100;
		return ($value)/$percent;
	}
	
	//массив параметров
	$params = $db->colModel->findOne( array('name'=>'chair'));

	//массив[uuid факультета] = title_ru
	$ff = $db->colDocs->find(array('type'=>'faculty'));
	foreach($ff as $f){
		$faculties[$f['uuid']] = $f['title_ru'];
	}
	//chairtypes[кафедра] = профиль
	$chairs = $db->colDocs->find(array('type'=>'chair'));
	foreach($chairs as $chair){
		//var_dump($chair);
		if(!isset($chair['chairtype'])){
		$chair['chairtype'] = 'P';
		var_dump('Не указан профиль - '.$chair['title_ru']);
		}
		$chairtypes[$chair['title_ru']] = $chair['chairtype']; //массив[кафедра] = профиль
	}

	//организовать вывод
	foreach($params['items'] as $item){
		if(isset($item['pdf']) && $item['pdf']){
			
			# вес показателей
			if(isset($item['pdf']) && $item['pdf']){
				if(isset($item['weight']) && $item['weight']>0){
					$weightlist[$item['index_code_ru']]['weight'] = $item['weight'];
					switch($item['type']){
					case 'section':
						$weightlist[$item['index_code_ru']]['type']='section';			
					break;
					case 'subsection':
						$weightlist[$item['index_code_ru']]['type']='subsection';				
					break;
					default:	
						$weightlist[$item['index_code_ru']]['type']='item';
					}	
				}else{
					$weightlist[$item['index_code_ru']]['weight'] = 0;
				//	$out['body'] .= '<p style="color:red;">У показателя с индексом ' . $item['index_code_ru'] . ' проблема "с весом"!!!</p>';
				}
			}
			# вес показателей
			
			$j = 0;
			if(isset($item['type'])){
				if($item['type'] == 'section'){
					//лишнее
					$itemtitles[$item['index_code_ru']] = $item['label_ru'];
					//$out['body'] .= '<div><h3 style="text-align:center;margin-top:45px;" id="' . $item['name'] . '">Раздел '.++$i.': <b>'.$item['label_ru'].'</b></h3></div>';
				}elseif($item['type'] == 'subsection'){
					//лишнее
					$itemtitles[$item['index_code_ru']] = $item['label_ru'];
					//$subtext = $item['label_ru'];
				}else{
					//$title = addcslashes($item['index_code_ru'].' '.$subtext.' '.$item['label_ru'], "'");
					//$title = addcslashes($title, '"');
					if($item['accumulative']){
						foreach($chairs as $chair){
							if(isset($chair[$item['name']])){
								$values[$chair['title_ru']] = $chair[$item['name']];
								if(!isset($chair['rates'])){
									$chair['rates']=1;
									var_dump('Не указаны ставки - '.$chair['title_ru']);
									} //плохо
								$values[$chair['title_ru']] = divide_on_the_rates($values[$chair['title_ru']],$chair['rates']);
								//if($values[$chair['title_ru']]<0)$values[$chair['title_ru']] = -$values[$chair['title_ru']];
							}
						}
					}else{
						foreach($chairs as $chair){
							$counter = 0;
							if(isset($chair[$item['name']])){
								$values[$chair['title_ru']] = $chair[$item['name']];
								if(isset($chair['versions'])){
									foreach($chair['versions'] as $version){
										$counter++;
										if($counter < 10) continue;

										if(isset($version['content']) && isset($version['content'][$item['name']])){
											$values[$chair['title_ru']] += $version['content'][$item['name']];
										}
									}
								}
								if(!isset($chair['rates'])){
									$chair['rates']=1;
									var_dump('Не указаны ставки - '.$chair['title_ru']);
									} //плохо
							$values[$chair['title_ru']] = divide_on_the_rates($values[$chair['title_ru']],$chair['rates']);
							}else{
								$values[$chair['title_ru']] = 0;
							}
						}
					}
					arsort($values);
					
				//	debug($item['index_code_ru']. ', вес: ' .$weightlist[$item['index_code_ru']]['weight']);
				//	debug('Кафедра русского языка: '.$values['Кафедра русского языка']);
				//	debug('Кафедра начального естественно-математического образования: '.$values['Кафедра начального естественно-математического образования']);
				//	debug('Кафедра управления образованием и кадрового менеджмента: '.$values['Кафедра управления образованием и кадрового менеджмента']);
					foreach($values as $key=>$value){
						if($value<0){
							$values[$key]=0;
						
						//	$out['body'] .= '<p style="color:red;"> Проблема с подразделением: "'.$key.'", показатель: "'.$item['index_code_ru'].'" = '.$value.' <b>в расчетах будет 0!</b></p>';
							
						}
					}
					//var_dump($values);
					$full_arr = $values;
					//array_splice($values, $topCount);
					foreach($values as $key => $value){
						if($value == 0 || !is_float($value)){
							unset($values[$key]);
						}else{
							//$values[$key] = round(castingWithMedian($full_arr, $chairsCounter, $value, $item['index_code_ru']),4);
							$values[$key] = round(actuation($full_arr, $value),4);
						}
					}
					$chair_arr[$item['index_code_ru']] = $values;
					unset($values,$full_arr);
				}

			}
		}
	}
	foreach($chair_arr as $code => $chairs){
		if($weightlist[$code]['type'] == 'subsection'){
			$lastsubcode = $code;
		}
		foreach($chairs as $chair => $value){
			if(isset($chair_arr[$code][$chair]) && $weightlist[$code]['type']=='item'){
				if($lastsubcode=='ОД.2.'){
					# Отдельная хрень для расчета ДПО
					if(isset($chair_arr['ОД.2.1.'][$chair]) && isset($chair_arr['ОД.2.2.'][$chair]) && $chair_arr['ОД.2.2.'][$chair] != 0){
						$od1 = 0.1 * $chair_arr['ОД.2.1.'][$chair]/$chair_arr['ОД.2.2.'][$chair];
					}else{
						$od1 = 0;
					}
					if(isset($chair_arr['ОД.2.3.'][$chair]) && isset($chair_arr['ОД.2.4.'][$chair]) && $chair_arr['ОД.2.4.'][$chair] != 0){
						$od2 = 0.3 * $chair_arr['ОД.2.3.'][$chair]/$chair_arr['ОД.2.4.'][$chair];
					}else{
						$od2 = 0;
					}
					$subratelist[$lastsubcode][$chair] = $od1 + $od2;
					unset($od1);
					unset($od2);
				}else{
					# Стандартный расчет
					$chairlist[$code][$chair] = $chair_arr[$code][$chair]*$weightlist[$code]['weight'];
					$subratelist[$lastsubcode][$chair] += $chairlist[$code][$chair];
				}
			}
		}
	}
	var_dump($subratelist);
//	var_dump($chair_arr);
?>
<!doctype html>
<html lang="ru">
<head>
<meta charset="utf-8" />
<title>Данные для ПФУ</title>
<link rel="stylesheet" href="/css/jquery-ui.css" />

<script src="/js/jquery-1.9.1.js"></script>
<script src="/js/jquery-ui.js"></script>
<script src="/js/jquery.form.js"></script>

<link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
<script src="/js/bootstrap.min.js"></script>
<link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.form.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/admin.css" />
<link rel="stylesheet" href="/css/navigation__horizontal.css" />
 <link rel="stylesheet" href="/css/messages.css" />

  <script src="/js/auth.js"></script>
  <script>
    var language = "<?=$language?>";
    var pageType = "<?=$pageType?>";

  </script>
  <style>
  table{width:100%}
  td,th{text-align:left; padding:2px 20px;}
  </style>
</head>

<body>


<header class="header gradient">
  <div class="header__logo">
    <img src="/images/herzen.png" />
  </div>
  <div class="header__headings">
    <h1 class="header__headings__heading">
      Комплексный мониторинг кафедр
    </h1>
    <h2 class="header__headings__subheading">
      <small class="header__headings__subheading__subsubheading">
        Аналитические данные для планово финансового управления
      </small>
    </h2>
  </div>

  <div class="userbox userbox_parent_header">
    <div class="userbox__controls">
      <span class="userbox__controls__profile">профиль</span> / <span class="userbox__controls__logout">выход</span>
    </div>
    <div class="userbox__username">
        <span class="userbox__username__displayname" data-uuid="<?=$this->user->uuid?>"><?=$this->user->givenname?> <?=$this->user->lastname?></span>
    </div>
  </div>

  <div class="header__helper"></div>
</header>

<div>
	<?php
echo $role->userMenu($user->uuid);
	?>
</div>
<!-- CURRENT PAGE -->
<div class="all">
Это страница ПФУ
</div>
</body>
</html>
